// Copyright 2020 the V8 project authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Flags: --allow-natives-syntax

var arr = new Uint8Array();
v8ArrayBufferDetach(arr.buffer);

function foo() {
  return arr[Symbol.iterator]();
}

v8PrepareFunctionForOptimization(foo);
assertThrows(foo, TypeError);
v8OptimizeFunctionOnNextCall(foo);
assertThrows(foo, TypeError);
