// Copyright 2018 the V8 project authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

d8.file.execute('lib/testv8/testv8-20210709/test/mjsunit/wasm/wasm-module-builder.js');

const builder = new WasmModuleBuilder();
builder.addMemory(16, 32);
builder.addFunction("test", kSig_i_v).addBody([
  kExprI32Const, 12,         // i32.const 12
]);

WebAssembly.Module.prototype.then = resolve => {
  assertUnreachable();
};

WebAssembly.instantiate(builder.toBuffer());
