// Copyright 2020 the V8 project authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Flags: --allow-natives-syntax --no-stress-opt

assertTrue(v8SetIteratorProtector());
assertTrue(v8MapIteratorProtector());
assertTrue(v8StringIteratorProtector());
assertTrue(v8ArrayIteratorProtector());
const arrayIteratorPrototype = Object.getPrototypeOf([].values());
Object.defineProperty(arrayIteratorPrototype, "next", { value: {}})
assertTrue(v8SetIteratorProtector());
assertTrue(v8MapIteratorProtector());
assertTrue(v8StringIteratorProtector());
assertFalse(v8ArrayIteratorProtector());
