// Copyright 2019 the V8 project authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Flags: --allow-natives-syntax --expose-gc

assertThrows = function assertThrows(code) {};
v8PrepareFunctionForOptimization(assertThrows);

function foo(val) {
  var arr = [];
  function bar() {
    function m1() {}
    v8PrepareFunctionForOptimization(m1);
    assertThrows(m1);
    0 in arr;
  }
  v8PrepareFunctionForOptimization(bar);
  bar();  // virtual context distance of 1 from native_context
  gc();
  bar(true);
}

v8PrepareFunctionForOptimization(foo);
foo();
foo();
v8OptimizeFunctionOnNextCall(foo);
foo();
